"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTransforms = exports.customWebpackConfigTransformFactory = exports.resolveChaining = void 0;
const core_1 = require("@angular-devkit/core");
const custom_webpack_builder_1 = require("@angular-builders/custom-webpack/dist/custom-webpack-builder");
const common_1 = require("@angular-builders/custom-webpack/dist/common");
function resolveChaining(options, workspaceRoot, target, browserWebpackConfig) {
    return __awaiter(this, void 0, void 0, function* () {
        const customWebpackConfig = options.customWebpackConfig;
        const chain = customWebpackConfig.chain || [];
        for (const path of chain) {
            browserWebpackConfig = yield custom_webpack_builder_1.CustomWebpackBuilder.buildWebpackConfig(core_1.normalize(workspaceRoot), Object.assign(Object.assign({}, customWebpackConfig), { path: path }), browserWebpackConfig, options, target);
        }
        return browserWebpackConfig;
    });
}
exports.resolveChaining = resolveChaining;
exports.customWebpackConfigTransformFactory = (options, { workspaceRoot, target }) => browserWebpackConfig => {
    return resolveChaining(options, workspaceRoot, target, browserWebpackConfig);
};
exports.getTransforms = (options, context) => ({
    webpackConfiguration: exports.customWebpackConfigTransformFactory(options, context),
    indexHtml: common_1.indexHtmlTransformFactory(options, context),
});
//# sourceMappingURL=common.js.map